--[[
	Bridge:	// Мосты, их изображение и позиция на карте
	[name]:
	X,Y,W,H - Tiles
	Floor - number
	Image - path
	SizeX,SizeY - size of image

	Ladder: (pit)	// Подъемы и ямы
	[id]
	X,Y,W,H - Tiles
	ToFloor - number
	Damage - number (def:0)

	Floor:			// Блокировка пути в стену
	X,Y,W,H - Tiles
	Floor - number
--]]

Floor=
{
	{
		X=4;
		Y=2;
		W=1;
		H=6;
		Floor=0;
		PushX=1;
	};
  	{
		X=4;
		Y=11;
		W=1;
		H=8;
		Floor=0;
		PushX=1;
	};
  	{
		X=26;
		Y=2;
		W=1;
		H=7;
		Floor=0;
		PushX=-1;
	};
	{
		X=26;
		Y=12;
		W=1;
		H=7;
		Floor=0;
		PushX=-1;
	}
}

Ladder=
{
	{
		X=5;
		Y=9;
		W=1;
		H=2;
		ToFloor=-1;
	};
	{
		X=4;
		Y=9;
		W=1;
		H=2;
		ToFloor=0;
	};
  {
		X=4;
		Y=2;
		W=1;
		H=7;
		ToFloor=-1;
    Damage=5;
	};
	{
		X=4;
		Y=11;
		W=1;
		H=8;
		ToFloor=-1;
    Damage=5;
	};
  {
		X=25;
		Y=10;
		W=1;
		H=2;
		ToFloor=-1;
	};
	{
		X=26;
		Y=10;
		W=1;
		H=2;
		ToFloor=0;
	};
    {
		X=26;
		Y=2;
		W=1;
		H=8;
		ToFloor=-1;
    Damage=5;
	};
	{
		X=26;
		Y=12;
		W=1;
		H=7;
		ToFloor=-1;
    Damage=5;
	};
}

Ladder=Ladder or {}
Floor=Floor or {}

addhook("spawn","PlayerInit")
addhook("movetile","PlayerMove")
addhook("move","PlayerMoving")
addhook("startround","RoundStart")

Pls={}

function PlayerInit(id)	-- После спавна игрока создаем для него мосты, если ещё не создали
	if(Pls[id])then
		Pls[id].Floor=0
		return
	end
	Pls[id]={Floor=0;Id=id;Imgs={}}
	local pl=Pls[id]
	end

function PlayerMove(id,x,y)	-- Проверка перехода по этажам
	local pl=Pls[id]
	for _,v in pairs(Ladder)do
		if(pl.Floor~=v.ToFloor)then
			if(x>=v.X and x<=v.X+v.W-1 and y>=v.Y and y<=v.Y+v.H-1)then
				pl.Floor=v.ToFloor
				if(v.Damage)then
					local health=player(id,"health")
					parse("sethealth "..id.." "..health-v.Damage)          
				end
				return
			end
		end 
	end
  pl.PX=x
  pl.PY=y
end

function PlayerMoving(id,x,y)	-- Блокировка перехода на этаж через "стену"
	local pl=Pls[id]
	for _,v in pairs(Floor)do
		if(pl.Floor<v.Floor)then
			if(x>=v.x and x<=v.w and y>=v.y and y<=v.h)then
				if(v.PushX>0)then
					x=x+v.w-x
				elseif(v.PushX<0)then
					x=x+v.x-x
				end
				if(v.PushY>0)then
					y=y+v.h-y
				elseif(v.PushY<0)then
					y=y+v.y-y
				end
				parse("setpos "..id.." "..x.." "..y)
			end
		end
	end
end

function RoundStart()	-- Запускаем весь этот хлам
	for k,v in pairs(Floor)do
		v.x=v.X*32-15
		v.y=v.Y*32-15
		v.w=v.W*32+v.x+30
		v.h=v.H*32+v.y+30
		v.PushX=v.PushX or 0
		v.PushY=v.PushY or 0
	end

	for _,id in pairs(player(0,"table"))do
		Pls={}
		PlayerInit(id)
	end
end

timer(0,"RoundStart")
